Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -3513,109 +3102,141 @@
 	struct yab *yab;
 	YList *buds;
-	int changed=0;
+	int changed = 0;
 	int id = yd->client_id;
-
-	if(over)
-		return;
-
-	while(find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB) 
-			&& (yab = yahoo_getyab(yid)) != NULL) {
-		if(!yab->id)
+	int yab_used = 0;
+
+	LOG(("Got data for YAB"));
+
+	if (over)
+		return;
+
+	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB)
+		&& (yab = yahoo_getyab(yid)) != NULL) {
+		if (!yab->id)
 			continue;
-		changed=1;
-		for(buds = yd->buddies; buds; buds=buds->next) {
-			struct yahoo_buddy * bud = buds->data;
-			if(!strcmp(bud->id, yab->id)) {
+
+		changed = 1;
+		yab_used = 0;
+		for (buds = yd->buddies; buds; buds = buds->next) {
+			struct yahoo_buddy *bud = buds->data;
+			if (!strcmp(bud->id, yab->id)) {
+				yab_used = 1;
 				bud->yab_entry = yab;
-				if(yab->nname) {
+				if (yab->nname) {
 					bud->real_name = strdup(yab->nname);
-				} else if(yab->fname && yab->lname) {
-					bud->real_name = y_new0(char, 
-							strlen(yab->fname)+
-							strlen(yab->lname)+2
-							);
+				} else if (yab->fname && yab->lname) {
+					bud->real_name = y_new0(char,
+						strlen(yab->fname) +
+						strlen(yab->lname) + 2);
 					sprintf(bud->real_name, "%s %s",
-							yab->fname, yab->lname);
-				} else if(yab->fname) {
+						yab->fname, yab->lname);
+				} else if (yab->fname) {
 					bud->real_name = strdup(yab->fname);
 				}
-				break; /* for */
+				break;	/* for */
 			}
 		}
-	}
-
-	if(changed)
-		YAHOO_CALLBACK(ext_yahoo_got_buddies)(yd->client_id, yd->buddies);
-}
-
-static void yahoo_process_search_connection(struct yahoo_input_data *yid, int over)
-{
-	struct yahoo_found_contact *yct=NULL;
+
+		if (!yab_used) {
+			FREE(yab->fname);
+			FREE(yab->lname);
+			FREE(yab->nname);
+			FREE(yab->id);
+			FREE(yab->email);
+			FREE(yab->hphone);
+			FREE(yab->wphone);
+			FREE(yab->mphone);
+			FREE(yab);
+		}
+
+	}
+
+	if (changed)
+		YAHOO_CALLBACK(ext_yahoo_got_buddies) (yd->client_id,
+			yd->buddies);
+}
+
+static void yahoo_process_search_connection(struct yahoo_input_data *yid,
+	int over)
+{
+	struct yahoo_found_contact *yct = NULL;
 	char *p = (char *)yid->rxqueue, *np, *cp;
 	int k, n;
-	int start=0, found=0, total=0;
-	YList *contacts=NULL;
-	struct yahoo_input_data *pyid = find_input_by_id_and_type(yid->yd->client_id, YAHOO_CONNECTION_PAGER);
-
-	if(!over || !pyid)
-		return;
-
-	if(p && (p=strstr(p, "\r\n\r\n"))) {
+	int start = 0, found = 0, total = 0;
+	YList *contacts = NULL;
+	struct yahoo_input_data *pyid =
+		find_input_by_id_and_type(yid->yd->client_id,
+		YAHOO_CONNECTION_PAGER);
+
+	if (!over || !pyid)
+		return;
+
+	if (p && (p = strstr(p, "\r\n\r\n"))) {
 		p += 4;
 
-		for(k = 0; (p = strchr(p, 4)) && (k < 4); k++) {
+		for (k = 0; (p = strchr(p, 4)) && (k < 4); k++) {
 			p++;
 			n = atoi(p);
-			switch(k) {
-				case 0: found = pyid->ys->lsearch_nfound = n; break;
-				case 2: start = pyid->ys->lsearch_nstart = n; break;
-				case 3: total = pyid->ys->lsearch_ntotal = n; break;
+			switch (k) {
+			case 0:
+				found = pyid->ys->lsearch_nfound = n;
+				break;
+			case 2:
+				start = pyid->ys->lsearch_nstart = n;
+				break;
+			case 3:
+				total = pyid->ys->lsearch_ntotal = n;
+				break;
 			}
 		}
 
-		if(p)
+		if (p)
 			p++;
 
-		k=0;
-		while(p && *p) {
+		k = 0;
+		while (p && *p) {
 			cp = p;
 			np = strchr(p, 4);
 
-			if(!np)
+			if (!np)
 				break;
 			*np = 0;
-			p = np+1;
-
-			switch(k++) {
-				case 1:
-					if(strlen(cp) > 2 && y_list_length(contacts) < total) {
-						yct = y_new0(struct yahoo_found_contact, 1);
-						contacts = y_list_append(contacts, yct);
-						yct->id = cp+2;
-					} else {
-						*p = 0;
-					}
-					break;
-				case 2: 
-					yct->online = !strcmp(cp, "2") ? 1 : 0;
-					break;
-				case 3: 
-					yct->gender = cp;
-					break;
-				case 4: 
-					yct->age = atoi(cp);
-					break;
-				case 5: 
-					if(strcmp(cp, "5") != 0)
-						yct->location = cp;
-					k = 0;
-					break;
+			p = np + 1;
+
+			switch (k++) {
+			case 1:
+				if (strlen(cp) > 2
+					&& y_list_length(contacts) < total) {
+					yct = y_new0(struct yahoo_found_contact,
+						1);
+					contacts = y_list_append(contacts, yct);
+					yct->id = cp + 2;
+				} else {
+					*p = 0;
+				}
+				break;
+			case 2:
+				yct->online = !strcmp(cp, "2") ? 1 : 0;
+				break;
+			case 3:
+				yct->gender = cp;
+				break;
+			case 4:
+				yct->age = atoi(cp);
+				break;
+			case 5:
+				/* not worth the context switch for strcmp */
+				if (cp[0] != '\005' || cp[1] != '\000')
+					yct->location = cp;
+				k = 0;
+				break;
 			}
 		}
 	}
 
-	YAHOO_CALLBACK(ext_yahoo_got_search_result)(yid->yd->client_id, found, start, total, contacts);
-
-	while(contacts) {
+	YAHOO_CALLBACK(ext_yahoo_got_search_result) (yid->yd->client_id, found,
+		start, total, contacts);
+
+	while (contacts) {
 		YList *node = contacts;
 		contacts = y_list_remove_link(contacts, node);
@@ -3625,5 +3246,5 @@
 }
 
-static void _yahoo_webcam_connected(int fd, int error, void *d)
+static void _yahoo_webcam_connected(void *fd, int error, void *d)
 {
 	struct yahoo_input_data *yid = d;
@@ -3631,12 +3252,12 @@
 	struct yahoo_data *yd = yid->yd;
 	char conn_type[100];
-	char *data=NULL;
-	char *packet=NULL;
-	unsigned char magic_nr[] = {1, 0, 0, 0, 1};
-	unsigned header_len=0;
-	unsigned int len=0;
-	unsigned int pos=0;
-
-	if(error || fd <= 0) {
+	char *data = NULL;
+	char *packet = NULL;
+	unsigned char magic_nr[] = { 1, 0, 0, 0, 1 };
+	unsigned header_len = 0;
+	unsigned int len = 0;
+	unsigned int pos = 0;
+
+	if (error || !fd) {
 		FREE(yid);
 		return;
@@ -3648,14 +3269,13 @@
 	LOG(("Connected"));
 	/* send initial packet */
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			data = strdup("<REQIMG>");
-			break;
-		case YAHOO_WEBCAM_UPLOAD:	
-			data = strdup("<SNDIMG>");
-			break;
-		default:
-			return;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		data = strdup("<REQIMG>");
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		data = strdup("<SNDIMG>");
+		break;
+	default:
+		return;
 	}
 	yahoo_add_to_send_queue(yid, data, strlen(data));
@@ -3663,36 +3283,35 @@
 
 	/* send data */
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			header_len = 8;
-			data = strdup("a=2\r\nc=us\r\ne=21\r\nu=");
-			data = y_string_append(data, yd->user);
-			data = y_string_append(data, "\r\nt=");
-			data = y_string_append(data, wcm->key);
-			data = y_string_append(data, "\r\ni=");
-			data = y_string_append(data, wcm->my_ip);
-			data = y_string_append(data, "\r\ng=");
-			data = y_string_append(data, wcm->user);
-			data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
-			snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
-			data = y_string_append(data, conn_type);
-			data = y_string_append(data, "\r\n");
-			break;
-		case YAHOO_WEBCAM_UPLOAD:
-			header_len = 13;
-			data = strdup("a=2\r\nc=us\r\nu=");
-			data = y_string_append(data, yd->user);
-			data = y_string_append(data, "\r\nt=");
-			data = y_string_append(data, wcm->key);
-			data = y_string_append(data, "\r\ni=");
-			data = y_string_append(data, wcm->my_ip);
-			data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
-			snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
-			data = y_string_append(data, conn_type);
-			data = y_string_append(data, "\r\nb=");
-			data = y_string_append(data, wcm->description);
-			data = y_string_append(data, "\r\n");
-			break;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		header_len = 8;
+		data = strdup("a=2\r\nc=us\r\ne=21\r\nu=");
+		data = y_string_append(data, yd->user);
+		data = y_string_append(data, "\r\nt=");
+		data = y_string_append(data, wcm->key);
+		data = y_string_append(data, "\r\ni=");
+		data = y_string_append(data, wcm->my_ip);
+		data = y_string_append(data, "\r\ng=");
+		data = y_string_append(data, wcm->user);
+		data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
+		snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
+		data = y_string_append(data, conn_type);
+		data = y_string_append(data, "\r\n");
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		header_len = 13;
+		data = strdup("a=2\r\nc=us\r\nu=");
+		data = y_string_append(data, yd->user);
+		data = y_string_append(data, "\r\nt=");
+		data = y_string_append(data, wcm->key);
+		data = y_string_append(data, "\r\ni=");
+		data = y_string_append(data, wcm->my_ip);
+		data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
+		snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
+		data = y_string_append(data, conn_type);
+		data = y_string_append(data, "\r\nb=");
+		data = y_string_append(data, wcm->description);
+		data = y_string_append(data, "\r\n");
+		break;
 	}
 
@@ -3701,19 +3320,17 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			packet[pos++] = 1;
-			packet[pos++] = 0;
-			break;
-		case YAHOO_WEBCAM_UPLOAD:
-			packet[pos++] = 5;
-			packet[pos++] = 0;
-			break;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		packet[pos++] = 1;
+		packet[pos++] = 0;
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		packet[pos++] = 5;
+		packet[pos++] = 0;
+		break;
 	}
 
 	pos += yahoo_put32(packet + pos, len);
-	if (wcm->direction == YAHOO_WEBCAM_UPLOAD)
-	{
+	if (wcm->direction == YAHOO_WEBCAM_UPLOAD) {
 		memcpy(packet + pos, magic_nr, sizeof(magic_nr));
 		pos += sizeof(magic_nr);
@@ -3724,5 +3341,7 @@
 	FREE(data);
 
-	yid->read_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, yid->fd, YAHOO_INPUT_READ, yid);
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id,
+		yid->fd, YAHOO_INPUT_READ, yid);
 }
 
@@ -3749,21 +3368,21 @@
 
 	LOG(("Connecting to: %s:%d", wcm->server, wcm->port));
-	YAHOO_CALLBACK(ext_yahoo_connect_async)(y->yd->client_id, wcm->server, wcm->port,
-			_yahoo_webcam_connected, yid);
-
-}
-
-static void yahoo_process_webcam_master_connection(struct yahoo_input_data *yid, int over)
-{
-	char* server;
+	YAHOO_CALLBACK(ext_yahoo_connect_async) (y->yd->client_id, wcm->server,
+		wcm->port, _yahoo_webcam_connected, yid, 0);
+
+}
+
+static void yahoo_process_webcam_master_connection(struct yahoo_input_data *yid,
+	int over)
+{
+	char *server;
 	struct yahoo_server_settings *yss;
 
-	if(over)
+	if (over)
 		return;
 
 	server = yahoo_getwebcam_master(yid);
 
-	if (server)
-	{
+	if (server) {
 		yss = yid->yd->server_settings;
 		yid->wcm->server = strdup(server);
@@ -3778,28 +3397,28 @@
 }
 
-static void yahoo_process_webcam_connection(struct yahoo_input_data *yid, int over)
+static void yahoo_process_webcam_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	int id = yid->yd->client_id;
-	int fd = yid->fd;
-
-	if(over)
+	void *fd = yid->fd;
+
+	if (over)
 		return;
 
 	/* as long as we still have packets available keep processing them */
-	while (find_input_by_id_and_fd(id, fd) 
-			&& yahoo_get_webcam_data(yid) == 1);
-}
-
-static void (*yahoo_process_connection[])(struct yahoo_input_data *, int over) = {
-	yahoo_process_pager_connection,
-	yahoo_process_ft_connection,
-	yahoo_process_yab_connection,
-	yahoo_process_webcam_master_connection,
-	yahoo_process_webcam_connection,
-	yahoo_process_chatcat_connection,
-	yahoo_process_search_connection,
-};
-
-int yahoo_read_ready(int id, int fd, void *data)
+	while (find_input_by_id_and_fd(id, fd)
+		&& yahoo_get_webcam_data(yid) == 1) ;
+}
+
+static void (*yahoo_process_connection[]) (struct yahoo_input_data *,
+	int over) = {
+yahoo_process_pager_connection, yahoo_process_ft_connection,
+		yahoo_process_yab_connection,
+		yahoo_process_webcam_master_connection,
+		yahoo_process_webcam_connection,
+		yahoo_process_chatcat_connection,
+		yahoo_process_search_connection};
+
+int yahoo_read_ready(int id, void *fd, void *data)
 {
 	struct yahoo_input_data *yid = data;
@@ -3807,14 +3426,13 @@
 	int len;
 
-	LOG(("read callback: id=%d fd=%d data=%p", id, fd, data));
-	if(!yid)
+	LOG(("read callback: id=%d fd=%p data=%p", id, fd, data));
+	if (!yid)
 		return -2;
 
-	
 	do {
-		len = read(fd, buf, sizeof(buf));
-	} while(len == -1 && errno == EINTR);
-
-	if(len == -1 && (errno == EAGAIN||errno == EINTR))	/* we'll try again later */
+		len = YAHOO_CALLBACK(ext_yahoo_read) (fd, buf, sizeof(buf));
+	} while (len == -1 && errno == EINTR);
+
+	if (len == -1 && (errno == EAGAIN || errno == EINTR))	/* we'll try again later */
 		return 1;
 
@@ -3823,25 +3441,28 @@
 		DEBUG_MSG(("len == %d (<= 0)", len));
 
-		if(yid->type == YAHOO_CONNECTION_PAGER) {
-			YAHOO_CALLBACK(ext_yahoo_error)(yid->yd->client_id, "Connection closed by server", 1, E_CONNECTION);
-		}
-
-		yahoo_process_connection[yid->type](yid, 1);
+		if (yid->type == YAHOO_CONNECTION_PAGER) {
+			YAHOO_CALLBACK(ext_yahoo_login_response) (yid->yd->
+				client_id, YAHOO_LOGIN_SOCK, NULL);
+		}
+
+		yahoo_process_connection[yid->type] (yid, 1);
 		yahoo_input_close(yid);
 
 		/* no need to return an error, because we've already fixed it */
-		if(len == 0)
+		if (len == 0)
 			return 1;
 
-		errno=e;
+		errno = e;
 		LOG(("read error: %s", strerror(errno)));
 		return -1;
 	}
 
-	yid->rxqueue = y_renew(unsigned char, yid->rxqueue, len + yid->rxlen);
+	yid->rxqueue =
+		y_renew(unsigned char, yid->rxqueue, len + yid->rxlen + 1);
 	memcpy(yid->rxqueue + yid->rxlen, buf, len);
 	yid->rxlen += len;
-
-	yahoo_process_connection[yid->type](yid, 0);
+	yid->rxqueue[yid->rxlen] = 0;
+
+	yahoo_process_connection[yid->type] (yid, 0);
 
 	return len;
@@ -3855,5 +3476,5 @@
 	yd = y_new0(struct yahoo_data, 1);
 
-	if(!yd)
+	if (!yd)
 		return 0;
 
@@ -3880,11 +3501,5 @@
 }
 
-struct connect_callback_data {
-	struct yahoo_data *yd;
-	int tag;
-	int i;
-};
-
-static void yahoo_connected(int fd, int error, void *data)
+static void yahoo_connected(void *fd, int error, void *data)
 {
 	struct connect_callback_data *ccd = data;
@@ -3894,16 +3509,35 @@
 	struct yahoo_server_settings *yss = yd->server_settings;
 
-	if(error) {
-		if(fallback_ports[ccd->i]) {
-			int tag;
+	if (error) {
+		int tag;
+		if (fallback_ports[ccd->i]) {
+			char *host = yss->pager_host;
+
+			if (!host)
+				host = yss->pager_host_list[ccd->server_i];
+
 			yss->pager_port = fallback_ports[ccd->i++];
-			tag = YAHOO_CALLBACK(ext_yahoo_connect_async)(yd->client_id, yss->pager_host,
-					yss->pager_port, yahoo_connected, ccd);
-
-			if(tag > 0)
-				ccd->tag=tag;
+			tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->
+				client_id, host, yss->pager_port,
+				yahoo_connected, ccd, 0);
+
+			if (tag > 0)
+				ccd->tag = tag;
+		} else if (yss->pager_host_list
+				&& yss->pager_host_list[ccd->server_i]) {
+
+			/* Get back to the default port */
+			yss->pager_port = pager_port;
+			ccd->server_i++;
+			LOG(("Fallback: Connecting to %s:%d", yss->pager_host_list[ccd->server_i], yss->pager_port));
+
+			ccd->i = 0;
+			tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id,
+				yss->pager_host_list[ccd->server_i], yss->pager_port,
+				yahoo_connected, ccd, 0);
 		} else {
 			FREE(ccd);
-			YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, YAHOO_LOGIN_SOCK, NULL);
+			YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+				YAHOO_LOGIN_SOCK, NULL);
 		}
 		return;
@@ -3912,17 +3546,16 @@
 	FREE(ccd);
 
-	/* fd < 0 && error == 0 means connect was cancelled */
-	if(fd < 0)
-		return;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	/* fd == NULL && error == 0 means connect was cancelled */
+	if (!fd)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 	NOTICE(("Sending initial packet"));
 
 	yahoo_packet_hash(pkt, 1, yd->user);
 
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
+	yid = find_input_by_id_and_type(yd->client_id, YAHOO_CONNECTION_PAGER);
 	yid->fd = fd;
-	inputs = y_list_prepend(inputs, yid);
 
 	yahoo_send_packet(yid, pkt, 0);
@@ -3930,41 +3563,14 @@
 	yahoo_packet_free(pkt);
 
-	yid->read_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, yid->fd, YAHOO_INPUT_READ, yid);
-}
-
-void yahoo_login(int id, int initial)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	struct connect_callback_data *ccd;
-	struct yahoo_server_settings *yss;
-	int tag;
-
-	if(!yd)
-		return;
-
-	yss = yd->server_settings;
-
-	yd->initial_status = initial;
-
-	ccd = y_new0(struct connect_callback_data, 1);
-	ccd->yd = yd;
-	tag = YAHOO_CALLBACK(ext_yahoo_connect_async)(yd->client_id, yss->pager_host, yss->pager_port, 
-			yahoo_connected, ccd);
-
-	/*
-	 * if tag <= 0, then callback has already been called
-	 * so ccd will have been freed
-	 */
-	if(tag > 0)
-		ccd->tag = tag;
-	else if(tag < 0)
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, YAHOO_LOGIN_SOCK, NULL);
-}
-
-
-int yahoo_get_fd(int id)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
-	if(!yid)
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id,
+		yid->fd, YAHOO_INPUT_READ, yid);
+}
+
+void *yahoo_get_fd(int id)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	if (!yid)
 		return 0;
 	else
@@ -3972,27 +3578,35 @@
 }
 
-void yahoo_send_im(int id, const char *from, const char *who, const char *what, int utf8, int picture)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_send_buzz(int id, const char *from, const char *who)
+{
+	yahoo_send_im(id, from, who, "<ding>", 1, 0);
+}
+
+void yahoo_send_im(int id, const char *from, const char *who, const char *what,
+	int utf8, int picture)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_packet *pkt = NULL;
 	struct yahoo_data *yd;
 	char pic_str[10];
 
-	if(!yid)
+	if (!yid)
 		return;
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE, YAHOO_STATUS_OFFLINE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE, YAHOO_STATUS_OFFLINE,
+		yd->session_id);
 
 	snprintf(pic_str, sizeof(pic_str), "%d", picture);
-	
-	if(from && strcmp(from, yd->user))
+
+	if (from && strcmp(from, yd->user))
 		yahoo_packet_hash(pkt, 0, yd->user);
-	yahoo_packet_hash(pkt, 1, from?from:yd->user);
+	yahoo_packet_hash(pkt, 1, from ? from : yd->user);
 	yahoo_packet_hash(pkt, 5, who);
 	yahoo_packet_hash(pkt, 14, what);
 
-	if(utf8)
+	if (utf8)
 		yahoo_packet_hash(pkt, 97, "1");
 
@@ -4001,5 +3615,4 @@
 	yahoo_packet_hash(pkt, 206, pic_str);
 
-
 	yahoo_send_packet(yid, pkt, 0);
 
@@ -4009,15 +3622,17 @@
 void yahoo_send_typing(int id, const char *from, const char *who, int typ)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
-	if(!yid)
+	if (!yid)
 		return;
 
 	yd = yid->yd;
-	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YAHOO_STATUS_NOTIFY, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YPACKET_STATUS_NOTIFY,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 5, who);
-	yahoo_packet_hash(pkt, 1, from?from:yd->user);
+	yahoo_packet_hash(pkt, 1, from ? from : yd->user);
 	yahoo_packet_hash(pkt, 14, " ");
 	yahoo_packet_hash(pkt, 13, typ ? "1" : "0");
@@ -4031,5 +3646,6 @@
 void yahoo_set_away(int id, enum yahoo_status state, const char *msg, int away)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
@@ -4037,8 +3653,9 @@
 	char s[4];
 
-	if(!yid)
+	if (!yid)
 		return;
 
 	yd = yid->yd;
+
 	old_status = yd->current_status;
 	yd->current_status = state;
@@ -4046,5 +3663,6 @@
 	/* Thank you libpurple :) */
 	if (yd->current_status == YAHOO_STATUS_INVISIBLE) {
-		pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_VISIBILITY, YAHOO_STATUS_AVAILABLE, 0);
+		pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_VISIBLE_TOGGLE,
+			YAHOO_STATUS_AVAILABLE, 0);
 		yahoo_packet_hash(pkt, 13, "2");
 		yahoo_send_packet(yid, pkt, 0);
@@ -4054,5 +3672,6 @@
 	}
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_STATUS_UPDATE, yd->current_status, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_STATUS_UPDATE,
+		yd->current_status, yd->session_id);
 	snprintf(s, sizeof(s), "%d", yd->current_status);
 	yahoo_packet_hash(pkt, 10, s);
@@ -4062,6 +3681,7 @@
 	yahoo_packet_free(pkt);
 
-	if(old_status == YAHOO_STATUS_INVISIBLE) {
-		pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_VISIBILITY, YAHOO_STATUS_AVAILABLE, 0);
+	if (old_status == YAHOO_STATUS_INVISIBLE) {
+		pkt = yahoo_packet_new(YAHOO_SERVICE_Y6_VISIBLE_TOGGLE,
+			YAHOO_STATUS_AVAILABLE, 0);
 		yahoo_packet_hash(pkt, 13, "1");
 		yahoo_send_packet(yid, pkt, 0);
@@ -4072,9 +3692,10 @@
 void yahoo_logoff(int id)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
@@ -4082,9 +3703,10 @@
 	LOG(("yahoo_logoff: current status: %d", yd->current_status));
 
-	if(yd->current_status != -1 && 0) {
+	if (yd->current_status != -1 && 0) {
 		/* Meh. Don't send this. The event handlers are not going to
 		   get to do this so it'll just leak memory. And the TCP
 		   connection reset will hopefully be clear enough. */
-		pkt = yahoo_packet_new(YAHOO_SERVICE_LOGOFF, YAHOO_STATUS_AVAILABLE, yd->session_id);
+		pkt = yahoo_packet_new(YAHOO_SERVICE_LOGOFF,
+			YPACKET_STATUS_DEFAULT, yd->session_id);
 		yd->current_status = -1;
 
@@ -4095,20 +3717,23 @@
 	}
 
-	do {
+/*	do {
 		yahoo_input_close(yid);
-	} while((yid = find_input_by_id(id)));
+	} while((yid = find_input_by_id(id)));*/
+
 }
 
 void yahoo_get_list(int id)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_LIST, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_LIST, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 	yahoo_packet_hash(pkt, 1, yd->user);
 	if (pkt) {
@@ -4118,8 +3743,8 @@
 }
 
-static void _yahoo_http_connected(int id, int fd, int error, void *data)
+static void _yahoo_http_connected(int id, void *fd, int error, void *data)
 {
 	struct yahoo_input_data *yid = data;
-	if(fd <= 0) {
+	if (fd == NULL || error) {
 		inputs = y_list_remove(inputs, yid);
 		FREE(yid);
@@ -4128,42 +3753,78 @@
 
 	yid->fd = fd;
-	yid->read_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, fd, YAHOO_INPUT_READ, yid);
-}
-
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+}
+
+/* FIXME Get address book from address.yahoo.com instead */
 void yahoo_get_yab(int id)
 {
+	struct yahoo_data *yd = find_conn_by_id(id);
+	struct yahoo_input_data *yid;
+	char url[1024];
+	char buff[2048];
+
+	if (!yd)
+		return;
+
+	yid = y_new0(struct yahoo_input_data, 1);
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_YAB;
+
+	LOG(("Sending request for Address Book"));
+
+	snprintf(url, 1024,
+		"http://address.yahoo.com/yab/us?v=XM&prog=ymsgr&.intl=us"
+		"&diffs=1&t=0&tags=short&rt=0&prog-ver=8.1.0.249&useutf8=1&legenc=codepage-1252");
+
+	snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y, yd->cookie_t);
+
+	inputs = y_list_prepend(inputs, yid);
+
+	yahoo_http_get(yid->yd->client_id, url, buff, 0, 0,
+		_yahoo_http_connected, yid);
+}
+
+struct yahoo_post_data {
+	struct yahoo_input_data *yid;
+	char *data;
+};
+
+static void _yahoo_http_post_connected(int id, void *fd, int error, void *data)
+{
+	struct yahoo_post_data *yad = data;
+	struct yahoo_input_data *yid = yad->yid;
+	char *buff = yad->data;
+
+	if (!fd) {
+		inputs = y_list_remove(inputs, yid);
+		FREE(yid);
+		return;
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_write) (fd, buff, strlen(buff));
+
+	yid->fd = fd;
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+
+	FREE(buff);
+	FREE(yad);
+}
+
+/* FIXME This is also likely affected */
+void yahoo_set_yab(int id, struct yab *yab)
+{
+	struct yahoo_post_data *yad = y_new0(struct yahoo_post_data, 1);
 	struct yahoo_data *yd = find_conn_by_id(id);
 	struct yahoo_input_data *yid;
 	char url[1024];
 	char buff[1024];
-
-	if(!yd)
-		return;
-
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
-	yid->type = YAHOO_CONNECTION_YAB;
-
-	snprintf(url, 1024, "http://insider.msg.yahoo.com/ycontent/?ab2=0");
-
-	snprintf(buff, sizeof(buff), "Y=%s; T=%s",
-			yd->cookie_y, yd->cookie_t);
-
-	inputs = y_list_prepend(inputs, yid);
-
-	yahoo_http_get(yid->yd->client_id, url, buff, 
-			_yahoo_http_connected, yid);
-}
-
-void yahoo_set_yab(int id, struct yab * yab)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	struct yahoo_input_data *yid;
-	char url[1024];
-	char buff[1024];
-	char *temp;
-	int size = sizeof(url)-1;
-
-	if(!yd)
+	char post[1024];
+	int size = 0;
+
+	if (!yd)
 		return;
 
@@ -4172,83 +3833,44 @@
 	yid->yd = yd;
 
-	strncpy(url, "http://insider.msg.yahoo.com/ycontent/?addab2=0", size);
-
-	if(yab->dbid) {
-		/* change existing yab */
-		char tmp[32];
-		strncat(url, "&ee=1&ow=1&id=", size - strlen(url));
-		snprintf(tmp, sizeof(tmp), "%d", yab->dbid);
-		strncat(url, tmp, size - strlen(url));
-	}
-
-	if(yab->fname) {
-		strncat(url, "&fn=", size - strlen(url));
-		temp = yahoo_urlencode(yab->fname);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	if(yab->lname) {
-		strncat(url, "&ln=", size - strlen(url));
-		temp = yahoo_urlencode(yab->lname);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	strncat(url, "&yid=", size - strlen(url));
-	temp = yahoo_urlencode(yab->id);
-	strncat(url, temp, size - strlen(url));
-	free(temp);
-	if(yab->nname) {
-		strncat(url, "&nn=", size - strlen(url));
-		temp = yahoo_urlencode(yab->nname);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	if(yab->email) {
-		strncat(url, "&e=", size - strlen(url));
-		temp = yahoo_urlencode(yab->email);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	if(yab->hphone) {
-		strncat(url, "&hp=", size - strlen(url));
-		temp = yahoo_urlencode(yab->hphone);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	if(yab->wphone) {
-		strncat(url, "&wp=", size - strlen(url));
-		temp = yahoo_urlencode(yab->wphone);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	if(yab->mphone) {
-		strncat(url, "&mp=", size - strlen(url));
-		temp = yahoo_urlencode(yab->mphone);
-		strncat(url, temp, size - strlen(url));
-		free(temp);
-	}
-	strncat(url, "&pp=0", size - strlen(url));
-
-	snprintf(buff, sizeof(buff), "Y=%s; T=%s",
-			yd->cookie_y, yd->cookie_t);
+	if(yab->yid)
+		size = snprintf(post, sizeof(post), "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
+			"<ab k=\"%s\" cc=\"%d\">"
+			"<ct id=\"%d\" e=\"1\" yi=\"%s\" nn=\"%s\" />"
+			"</ab>", yd->user, 9, yab->yid,	/* Don't know why */
+			yab->id, yab->nname?yab->nname:"");
+	else
+		size = snprintf(post, sizeof(post), "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
+			"<ab k=\"%s\" cc=\"%d\">"
+			"<ct a=\"1\" yi=\"%s\" nn=\"%s\" />"
+			"</ab>", yd->user, 1,	/* Don't know why */
+			yab->id, yab->nname?yab->nname:"");
+
+	yad->yid = yid;
+	yad->data = strdup(post);
+
+	strcpy(url, "http://address.yahoo.com/yab/us?v=XM&prog=ymsgr&.intl=us"
+		"&sync=1&tags=short&noclear=1&useutf8=1&legenc=codepage-1252");
+
+	snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y, yd->cookie_t);
 
 	inputs = y_list_prepend(inputs, yid);
 
-	yahoo_http_get(yid->yd->client_id, url, buff, 
-			_yahoo_http_connected, yid);
-}
-
-void yahoo_set_identity_status(int id, const char * identity, int active)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yahoo_http_post(yid->yd->client_id, url, buff, size,
+		_yahoo_http_post_connected, yad);
+}
+
+void yahoo_set_identity_status(int id, const char *identity, int active)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(active?YAHOO_SERVICE_IDACT:YAHOO_SERVICE_IDDEACT,
-			YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(active ? YAHOO_SERVICE_IDACT :
+		YAHOO_SERVICE_IDDEACT, YPACKET_STATUS_DEFAULT, yd->session_id);
 	yahoo_packet_hash(pkt, 3, identity);
 	if (pkt) {
@@ -4260,13 +3882,15 @@
 void yahoo_refresh(int id)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_USERSTAT, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_USERSTAT, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 	if (pkt) {
 		yahoo_send_packet(yid, pkt, 0);
@@ -4277,39 +3901,45 @@
 void yahoo_keepalive(int id)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
-	struct yahoo_packet *pkt=NULL;
-	if(!yid)
+	struct yahoo_packet *pkt = NULL;
+	if (!yid)
 		return;
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PING, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PING, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 	yahoo_send_packet(yid, pkt, 0);
 	yahoo_packet_free(pkt);
 }
 
-void yahoo_chat_keepalive (int id)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type (id, YAHOO_CONNECTION_PAGER);
+void yahoo_chat_keepalive(int id)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
 
 	if (!yid)
-	    return;
+		return;
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new (YAHOO_SERVICE_CHATPING, YAHOO_STATUS_AVAILABLE, yd->session_id);
-	yahoo_send_packet (yid, pkt, 0);
-	yahoo_packet_free (pkt);
-}
-
-void yahoo_add_buddy(int id, const char *who, const char *group, const char *msg)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_CHATPING, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
+	yahoo_send_packet(yid, pkt, 0);
+	yahoo_packet_free(pkt);
+}
+
+void yahoo_add_buddy(int id, const char *who, const char *group,
+	const char *msg)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 
-	if(!yid)
+	if (!yid)
 		return;
 	yd = yid->yd;
